import { Config as GeneratedTypes } from 'payload/generated-types';
import find from './find';
import findByID from './findByID';
import create from './create';
import { ByIDOptions as UpdateByIDOptions, ManyOptions as UpdateManyOptions } from './update';
import { ByIDOptions as DeleteByIDOptions, ManyOptions as DeleteManyOptions } from './delete';
import findVersionByID from './findVersionByID';
import findVersions from './findVersions';
import restoreVersion from './restoreVersion';
import { BulkOperationResult } from '../../config/types';
declare function localUpdate<T extends keyof GeneratedTypes['collections']>(options: UpdateByIDOptions<T>): Promise<GeneratedTypes['collections'][T]>;
declare function localUpdate<T extends keyof GeneratedTypes['collections']>(options: UpdateManyOptions<T>): Promise<BulkOperationResult<T>>;
declare function localDelete<T extends keyof GeneratedTypes['collections']>(options: DeleteByIDOptions<T>): Promise<GeneratedTypes['collections'][T]>;
declare function localDelete<T extends keyof GeneratedTypes['collections']>(options: DeleteManyOptions<T>): Promise<BulkOperationResult<T>>;
declare const _default: {
    find: typeof find;
    findByID: typeof findByID;
    create: typeof create;
    update: typeof localUpdate;
    localDelete: typeof localDelete;
    auth: {
        login: typeof import("../../../auth/operations/local/login").default;
        forgotPassword: typeof import("../../../auth/operations/local/forgotPassword").default;
        resetPassword: typeof import("../../../auth/operations/local/resetPassword").default;
        unlock: typeof import("../../../auth/operations/local/unlock").default;
        verifyEmail: typeof import("../../../auth/operations/local/verifyEmail").default;
    };
    findVersionByID: typeof findVersionByID;
    findVersions: typeof findVersions;
    restoreVersion: typeof restoreVersion;
};
export default _default;
